#include "s0039_combination_sum.hpp"

void combinationSumDFS(vector<int> &candidates, int target, int startIndex,
                       vector<int> &path, int sum,
                       vector<vector<int>> &result) {
  // 结束条件：总和等于 target 。不存在总和大于 target 的情况，因为已经被剪枝了
  if (sum == target) {
    result.push_back(path);
    return;
  }

  // 开始迭代
  int size = candidates.size();
  for (int i = startIndex; i < size; ++i) {
    // 剪枝，当现在节点的 sum 已经超过了 target，就没必要继续迭代了
    if (sum + candidates[i] > target) break;
    path.push_back(candidates[i]);
    combinationSumDFS(candidates, target, i, path, sum + candidates[i], result);
    path.pop_back();
  }
}

vector<vector<int>> S0039::combinationSum(vector<int> &candidates, int target) {
  // 对 candidates 进行升序排序，这是为了进行剪枝
  sort(candidates.begin(), candidates.end());
  // 初始化
  vector<int> path{};
  vector<vector<int>> result{};
  combinationSumDFS(candidates, target, 0, path, 0, result);
  return result;
}
