#include "s0046_permutations.hpp"

void permuteDFS(vector<int> &path, vector<vector<int>> &result,
                vector<bool> &used, vector<int> &nums) {
  int len = nums.size();
  // 终止条件
  if (path.size() == len) {
    result.push_back(path);
    return;
  }

  // 开始迭代
  for (int i{0}; i < len; ++i) {
    // 如果当前元素使用过，则跳过
    if (used[i]) continue;
    // 否则处理当前节点
    path.push_back(nums[i]);
    used[i] = true;
    permuteDFS(path, result, used, nums);
    used[i] = false;
    path.pop_back();
  }
}

vector<vector<int>> S0046::permute(vector<int> &nums) {
  vector<int> path{};
  vector<vector<int>> result{};
  vector<bool> used(nums.size(), false);
  permuteDFS(path, result, used, nums);
  return result;
}
