#include "s0047_permutations_ii.hpp"

void permuteUniqueDFS(vector<int> &path, vector<vector<int>> &result,
                      vector<bool> &used, vector<int> &nums, int startIndex) {
  int len = nums.size();
  // 终止条件
  if (path.size() == len) {
    result.push_back(path);
    return;
  }

  // 开始迭代
  for (int i{0}; i < len; ++i) {
    // 如果当前元素在树层使用过，则跳过
    if (used[i] || (i > 0 && nums[i] == nums[i - 1] && used[i - 1] == false))
      continue;
    // 否则处理当前节点
    path.push_back(nums[i]);
    used[i] = true;
    permuteUniqueDFS(path, result, used, nums, i + 1);
    used[i] = false;
    path.pop_back();
  }
}

vector<vector<int>> S0047::permuteUnique(vector<int> &nums) {
  vector<int> path{};
  vector<vector<int>> result{};
  vector<bool> used(nums.size(), false);
  sort(nums.begin(), nums.end());
  permuteUniqueDFS(path, result, used, nums, 0);
  return result;
}
